package jp.halfmoon.inaba.aiwolf.guess;

import jp.halfmoon.inaba.aiwolf.learn.AgentStatistics;
import jp.halfmoon.inaba.aiwolf.lib.Judge;
import org.aiwolf.common.data.Role;

import java.util.ArrayList;

/**
 * uPړ[錾vNX
 */
public final class Learn_1dCompetitionDevine extends AbstractGuessStrategy {

	AgentStatistics agentStatistics;

	public Learn_1dCompetitionDevine(AgentStatistics agentStatistics){
		this.agentStatistics = agentStatistics;
	}

	@Override
	public ArrayList<Guess> getGuessList(GuessStrategyArgs args) {
		// Xg
		ArrayList<Guess> guesses = new ArrayList<Guess>();

		// ͍sȂ
		if( args.agi.latestGameInfo.getDay() < 1 ){
			return guesses;
		}

		// 10ł͍sȂ
		if( args.agi.latestGameInfo.getDay() == 1 && args.agi.getMyTalkNum() == 0 ){
			return guesses;
		}

		for( int seer : args.agi.getEnableCOAgentNo(Role.SEER) ){
			for( Judge judge : args.agi.getSeerJudgeList() ){
				if( judge.agentNo == seer ){
					if( args.agi.getCORole(judge.targetAgentNo, 1, 0) != null ){
						// 肢
						ArrayList<Guess> rguesses = agentStatistics.statistics.get(judge.agentNo).getGuessFromEvent("1dCompetitionDevine", args.agi.gameSetting);

						for( Guess guess : rguesses ){
							guess.correlation = Math.pow(guess.correlation, 0.6);
							guesses.add(guess);
						}
					}else{
						// O[肢
						ArrayList<Guess> rguesses = agentStatistics.statistics.get(judge.agentNo).getGuessFromEvent("1dNotCompetitionDevine", args.agi.gameSetting);

						for( Guess guess : rguesses ){
							guess.correlation = Math.pow(guess.correlation, 0.6);
							guesses.add(guess);
						}
					}
					break;
				}
			}
		}

		// XgԂ
		return guesses;
	}

}
