package jp.halfmoon.inaba.aiwolf.request;

import jp.halfmoon.inaba.aiwolf.lib.VoteAnalyzer;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.net.GameInfo;

import java.util.ArrayList;


/**
 * spu݂v
 */
public final class AvoidExecute_Werewolf extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		GameInfo gameInfo = args.agi.latestGameInfo;

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;

		// ͏YȂ̂ŕKvȂ
		if( gameInfo.getDay() <= 0 ){
			return Requests;
		}

		// Sڂ܂ł͂Ƃ肠sȂ
		if( args.agi.getMyTalkNum() < 4 ){
			return Requests;
		}


		// 錾ςݓ[͂̕擾
		VoteAnalyzer voteAnalyzer = VoteAnalyzer.loadSaidVote(args.agi);



		// P[łĂ
		if( !voteAnalyzer.getMaxReceiveVoteAgent().isEmpty() ){

			// [MAX擾
			int receiveVoteCountMax = voteAnalyzer.getReceiveVoteCount(voteAnalyzer.getMaxReceiveVoteAgent().get(0));

			// ̓[擾
			int receiveVoteCountWolf = 0;

			for( int wolf : args.agi.getAliveWolfList() ){
				int receiveVoteCount = voteAnalyzer.receiveVoteCount.getOrDefault(Agent.getAgent(wolf), 0);
				receiveVoteCountWolf = Math.max(receiveVoteCountWolf, receiveVoteCount);
			}

			// [ɒ[ɏȂȂsȂ
			if( receiveVoteCountWolf <= 1 ){
				return Requests;
			}

			// ̓[[MAX-1ȏȂ݂vZKvi-1̓qXeVX̂߁j
			if( receiveVoteCountWolf >= receiveVoteCountMax - 1 ){

				// G[WFg
				for( Agent agent : gameInfo.getAliveAgentList() ){

					// T̓XLbv
					if( args.agi.getAliveWolfList().contains(agent.getAgentIdx()) ){
						continue;
					}

					// G[WFg̓[擾
					int receiveVoteCount = voteAnalyzer.receiveVoteCount.getOrDefault(agent, 0);

					// ̓[łΕ[-1vZ
					if( agent.equals( voteAnalyzer.getVoteTarget(gameInfo.getAgent()) ) ){
						receiveVoteCount--;
					}

					if( receiveVoteCount + 1 > receiveVoteCountWolf ){
						// ƂP[ŘT蓾[Ȃ
						workReq = new Request(agent);
						workReq.vote = 1.15;
						Requests.add(workReq);
					}else if( receiveVoteCount + 1 >= receiveVoteCountWolf ){
						// ƂP[ŘTƓ[ɂȂ
						workReq = new Request(agent);
						workReq.vote = 1.1;
						Requests.add(workReq);
					}

				}

			}

		}

		return Requests;

	}

}
