package jp.halfmoon.inaba.aiwolf.request;

import java.util.ArrayList;
import java.util.HashSet;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.net.GameInfo;

import jp.halfmoon.inaba.aiwolf.guess.InspectedWolfsidePattern;
import jp.halfmoon.inaba.aiwolf.lib.CauseOfDeath;
import jp.halfmoon.inaba.aiwolf.lib.Common;


/**
 * spulݐisv
 */
public final class CheckmateExecute extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		GameInfo gameInfo = args.agi.latestGameInfo;

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;

		// ꐔvZ
		int executeNum = Common.getRestExecuteCount(gameInfo.getAliveAgentList().size());

		//TODO ҐΉ
		// ݂萔[orŏIȂvZ͍sȂ
		if( executeNum > 4 || executeNum <= 1 ){
			return Requests;
		}

		// lOp^[̍őXRA
		double maxScore = args.aguess.getMostValidPattern().score;

		// PPtO
		HashSet<Integer> PPFlag = new HashSet<Integer>();
		// LWtO
		HashSet<Integer> LWFlag = new HashSet<Integer>();

		// SlOp^[𑖍
		for( InspectedWolfsidePattern iPattern : args.aguess.getAllPattern().values() ){

			double score = iPattern.score;

			// XRAp^[͖
			if( score < maxScore * 0.2 ){
				continue;
			}

			// lÕJEg
			int aliveWolfSideNum = 0;
			int aliveWolfNum = 0;
			for( int wolf : iPattern.pattern.wolfAgentNo ){
				if( args.agi.agentState[wolf].causeofDeath == CauseOfDeath.ALIVE ){
					aliveWolfSideNum++;
					aliveWolfNum++;
				}
			}
			for( int possessed : iPattern.pattern.possessedAgentNo ){
				if( args.agi.agentState[possessed].causeofDeath == CauseOfDeath.ALIVE ){
					aliveWolfSideNum++;
				}
			}

			// cTP
			if( aliveWolfNum == 1 ){
				for( int wolf : iPattern.pattern.wolfAgentNo ){
					if( args.agi.agentState[wolf].causeofDeath == CauseOfDeath.ALIVE ){
						LWFlag.add(wolf);
					}
				}
			}

			// ݂~XPPɂȂ邩i݂萔lOłΊYj
			if( executeNum == aliveWolfSideNum ){
				// TwcɊ܂܂Ȃ҂݂PP
				for( Agent agent : gameInfo.getAliveAgentList() ){
					int agentNo = agent.getAgentIdx();
					if( !iPattern.pattern.isWolfSide(agentNo) ){
						PPFlag.add(agentNo);
					}
				}
			}

		}

		// LW̓󂪑݁A݂ĂPPȂȂ݂
		for( int agentNo : LWFlag ){
			if( !PPFlag.contains(PPFlag) ){
				workReq = new Request(agentNo);
				workReq.vote = 1.6;
				Requests.add(workReq);
			}
		}


		return Requests;

	}

}
