package jp.halfmoon.inaba.aiwolf.request;

import jp.halfmoon.inaba.aiwolf.lib.VoteAnalyzer;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;

import java.util.ArrayList;


/**
 * spu[uv
 */
public final class PossessedMove extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		GameInfo gameInfo = args.agi.latestGameInfo;

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;



		// 錾ςݓ[͂̕擾
		VoteAnalyzer voteAnalyzer = VoteAnalyzer.loadSaidVote(args.agi);


		for( Agent agent : gameInfo.getAliveAgentList() ){
			// _Ŋm
			if( args.agi.selfRealRoleViewInfo.isFixBlack(agent.getAgentIdx()) ){
				// Tlɓ[Ȃ
				workReq = new Request(agent);
				workReq.vote = 0.9;
				Requests.add(workReq);

				Agent target = voteAnalyzer.getVoteTarget(agent);
				// [錾Ă邩
				if( target != null ){
					// TlƓꏊɓ[
					workReq = new Request(target);
					workReq.vote = 1.2;
					Requests.add(workReq);
				}
			}else if( args.agi.selfRealRoleViewInfo.isFixWhite(agent.getAgentIdx()) ){
				// Tɓ[
				workReq = new Request(agent);
				workReq.vote = 1.1;
				Requests.add(workReq);
			}
		}


		return Requests;

	}

}
