package jp.halfmoon.inaba.aiwolf.strategyplayer;

import java.util.ArrayList;
import java.util.List;

import jp.halfmoon.inaba.aiwolf.learn.AgentStatistics;
import jp.halfmoon.inaba.aiwolf.lib.CauseOfDeath;
import jp.halfmoon.inaba.aiwolf.lib.Judge;
import jp.halfmoon.inaba.aiwolf.lib.ViewpointInfo;

import org.aiwolf.client.lib.TemplateTalkFactory;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;


public class StrategyPossessed extends AbstractBaseStrategyPlayer {


	/**
	 * RXgN^
	 * @param agentStatistics
	 */
	public StrategyPossessed(AgentStatistics agentStatistics) {
		super(agentStatistics);
	}


	@Override
	public void dayStart() {

	    try{
			super.dayStart();

			// x蔻̒ǉ
			if( agi.latestGameInfo.getDay() > 0 ){
				addFakeSeerJudge();
			}
	    }catch(Exception ex){
	        // OăX[
	        if(isRethrowException){
	            throw ex;
	        }

	        // ȉAȎ֏s(߂l郁\bh̏ꍇ͖߂)
	        // Do nothing
	    }

	}

	@Override
	public String talk() {

		try{
			String workString;

			// PP̔
			if( agi.isEnablePowerPlay_Possessed() ){
				// [ύX
				actionUI.voteAgent = planningVoteAgent;
				declaredPlanningVoteAgent = planningVoteAgent;

				// b
				String ret = TemplateTalkFactory.vote( Agent.getAgent(planningVoteAgent) );
				return ret;
			}

			// CȌꍇ
			if( !isCameOut ){
				isCameOut = true;

				String ret = TemplateTalkFactory.comingout( getMe(), fakeRole );
				return ret;
			}

			// COς̏ꍇ
			if( isCameOut ){

				// 񍐂̌ʂ񍐂
				if( agi.reportSelfResultCount < agi.selfInspectList.size() ){

					Judge reportJudge = agi.selfInspectList.get( agi.selfInspectList.size() - 1 );

					// 񍐍ς݂̌𑝂₷
					agi.reportSelfResultCount++;

					// b
					String ret = TemplateTalkFactory.divined( Agent.getAgent(reportJudge.targetAgentNo), reportJudge.result );
					return ret;
				}

			}

			// [ĂȂꍇAV[b
			if( declaredPlanningVoteAgent == null ){
				// [ύX
				actionUI.voteAgent = planningVoteAgent;
				declaredPlanningVoteAgent = planningVoteAgent;

				// ŏI͘T̕֏[hߐ錾ȂB錾͍ŏIȊOƂiƂڂőƓ킹j
				if( agi.latestGameInfo.getAliveAgentList().size() > 4 ){
					// b
					String ret = TemplateTalkFactory.vote( Agent.getAgent(planningVoteAgent) );
					return ret;
				}
			}

			// ^T̐lȏ㌾ĂȂΘb
			if( agi.talkedSuspicionAgentList.size() < agi.gameSetting.getRoleNumMap().get(Role.WEREWOLF) ){
				// ^b͂擾A擾łĂΘb
				workString = getSuspicionTalkString();
				if( workString != null ){
					return workString;
				}
			}

			// [ύXꍇAV[b
			if( declaredPlanningVoteAgent != planningVoteAgent ){
				// [ύX
				actionUI.voteAgent = planningVoteAgent;
				declaredPlanningVoteAgent = planningVoteAgent;

				// ŏI͘T̕֏[hߐ錾ȂB錾͍ŏIȊOƂiƂڂőƓ킹j
				if( agi.latestGameInfo.getAliveAgentList().size() > 4 ){
					// b
					String ret = TemplateTalkFactory.vote( Agent.getAgent(planningVoteAgent) );
					return ret;
				}
			}

			// ^b͂擾A擾łĂΘb
			workString = getSuspicionTalkString();
			if( workString != null ){
				return workString;
			}

			// Mpb͂擾A擾łĂΘb
			workString = getTrustTalkString();
			if( workString != null ){
				return workString;
			}

			// bꍇAoverԂ
			return TemplateTalkFactory.over();

		}catch(Exception ex){
	        // OăX[
	        if(isRethrowException){
	            throw ex;
	        }

	        // ȉAȎ֏s(߂l郁\bh̏ꍇ͖߂)

			// G[overԂ
			return TemplateTalkFactory.over();

		}

	}


	/** xEݒ肷 */
	@Override
	protected void setFakeRole(){
		setFakeRole(Role.SEER);
	}


	/**
	 * 肢ǉ
	 */
	private void addFakeSeerJudge(){

		GameInfo gameInfo = agi.latestGameInfo;

		// E茋ʂ̉ݒ
		int inspectAgentNo = latestRequest.getMaxInspectRequest().agentNo;
		Species result = Species.HUMAN;

		// PꂽG[WFg̎擾
		Agent attackedAgent = agi.latestGameInfo.getAttackedAgent();

		List<Integer> seers = agi.getEnableCOAgentNo(Role.SEER);
		List<Integer> mediums = agi.getEnableCOAgentNo(Role.MEDIUM);

		// j]
		if( agi.selfViewInfo.wolfsidePatterns.isEmpty() ){
			// Ă鋶_̊mT
			List<Integer> whiteList = new ArrayList<Integer>();
			for( int i = 1; i <= agi.gameSetting.getPlayerNum(); i++ ){
				if( agi.agentState[i].causeofDeath == CauseOfDeath.ALIVE && agi.selfRealRoleViewInfo.isFixWhite(i) ){
					whiteList.add(i);
				}
			}
			// mɍo
			if( !whiteList.isEmpty() ){
				inspectAgentNo = whiteList.get(0);
				result = Species.WEREWOLF;

				Judge newJudge = new Judge( getMe().getAgentIdx(),
                        inspectAgentNo,
                        result,
                        null );

				agi.addFakeSeerJudge(newJudge);
				return;
			}

		}

		//TODO UŏĔf
//		// ͍oŋAs(4COȉ̏ꍇ)
//		List<Integer> seers = agi.getEnableCOAgentNo(Role.SEER);
//		List<Integer> mediums = agi.getEnableCOAgentNo(Role.MEDIUM);
//		if( agi.latestGameInfo.getDay() == 1 && seers.size() + mediums.size() <= 4 ){
//			result = Species.WEREWOLF;
//		}


//		// \ɍo
//		if( agi.latestGameInfo.getDay() == 1 && mediums.size() == 1 ){
//			for( Integer medium : mediums ){
//				if( agi.agentState[medium].causeofDeath == CauseOfDeath.ALIVE &&
//					!agi.selfViewInfo.isFixWhite(medium) &&
//					!agi.selfViewInfo.isFixBlack(medium) ){
//					inspectAgentNo = medium;
//					result = Species.WEREWOLF;
//				}
//			}
//		}
//
//		// ΍Rɍo
//		if( agi.latestGameInfo.getDay() > 1 && seers.size() == 2 ){
//			for( Integer seer : seers ){
//				if( agi.agentState[seer].causeofDeath == CauseOfDeath.ALIVE &&
//					!agi.selfViewInfo.isFixWhite(seer) &&
//					!agi.selfViewInfo.isFixBlack(seer) ){
//					inspectAgentNo = seer;
//					result = Species.WEREWOLF;
//				}
//			}
//		}

//		// \ɍo
//		if( agi.latestGameInfo.getDay() == 2 && mediums.size() == 1 ){
//			for( Integer medium : mediums ){
//				if( agi.agentState[medium].causeofDeath == CauseOfDeath.ALIVE &&
//					!agi.selfViewInfo.isFixWhite(medium) &&
//					!agi.selfViewInfo.isFixBlack(medium) ){
//					inspectAgentNo = medium;
//					result = Species.WEREWOLF;
//				}
//			}
//		}
//
//		// ΍Rɍo
//		if( agi.latestGameInfo.getDay() == 1 && seers.size() == 2 ){
//			for( Integer seer : seers ){
//				if( agi.agentState[seer].causeofDeath == CauseOfDeath.ALIVE &&
//					!agi.selfViewInfo.isFixWhite(seer) &&
//					!agi.selfViewInfo.isFixBlack(seer) ){
//					inspectAgentNo = seer;
//					result = Species.WEREWOLF;
//				}
//			}
//		}



		// oꍇ̎_肷
		ViewpointInfo future = new ViewpointInfo(agi.selfViewInfo);
		future.removeWolfPattern(inspectAgentNo);

		// oœ󂪔j]ꍇAos
		if( future.wolfsidePatterns.isEmpty() ){
			result = Species.WEREWOLF;
		}


		// 肨Ƃ悪܂ꂽ
		if( attackedAgent != null && attackedAgent.getAgentIdx() == inspectAgentNo ){
			// ݐɂ͐lԔo
			result = Species.HUMAN;
		}


		// \S
		boolean mediumAlive = false;
		if( !mediums.isEmpty() ){
			for( int medium : mediums ){
				if( agi.agentState[medium].causeofDeath == CauseOfDeath.ALIVE ){
					// 1lłĂΐ
					mediumAlive = true;
				}else{
					// S삪^m肩
					if( agi.selfRealRoleViewInfo.isFixWhite(medium) ){
						mediumAlive = false;
						break;
					}
				}
			}
			// \S
			if( mediumAlive == false ){
				// 40%Ŕɍo
				if( Math.random() < 0.4 ){
					// ĂmT
					List<Integer> whiteList = new ArrayList<Integer>();
					for( int i = 1; i <= agi.gameSetting.getPlayerNum(); i++ ){
						if( agi.agentState[i].causeofDeath == CauseOfDeath.ALIVE && agi.selfRealRoleViewInfo.isFixWhite(i) ){
							whiteList.add(i);
						}
					}

					// _̊mɍo
					for( Integer white : whiteList ){
						// 莋_ŐFm肵Ăꍇ͐Ȃ
						if( agi.selfViewInfo.isFixWhite(white) ||
						    agi.selfViewInfo.isFixBlack(white) ){
							continue;
						}

						// oꍇ̎_肷
						future = new ViewpointInfo(agi.selfViewInfo);
						future.removePatternFromJudge( getMe().getAgentIdx(), white, Species.WEREWOLF );

						// oĔj]ȂȂ炻ɍo
						if( !future.wolfsidePatterns.isEmpty() ){
							inspectAgentNo = white;
							result = Species.WEREWOLF;
							break;
						}
					}
				}
			}
		}



		// ҂TȉiPl݂PPmj
		if( gameInfo.getAliveAgentList().size() <= 5 ){

			// ĂmT
			List<Integer> whiteList = new ArrayList<Integer>();
			for( int i = 1; i <= agi.gameSetting.getPlayerNum(); i++ ){
				if( agi.agentState[i].causeofDeath == CauseOfDeath.ALIVE && agi.selfRealRoleViewInfo.isFixWhite(i) ){
					whiteList.add(i);
				}
			}

			// _̊mɍo
			for( Integer white : whiteList ){
				// 莋_ŐFm肵Ăꍇ͐Ȃ
				if( agi.selfViewInfo.isFixWhite(white) ||
				    agi.selfViewInfo.isFixBlack(white) ){
					continue;
				}

				// oꍇ̎_肷
				future = new ViewpointInfo(agi.selfViewInfo);
				future.removePatternFromJudge( getMe().getAgentIdx(), white, Species.WEREWOLF );

				// oĔj]ȂȂ炻ɍo
				if( !future.wolfsidePatterns.isEmpty() ){
					inspectAgentNo = white;
					result = Species.WEREWOLF;
					break;
				}
			}

		}

		// mƃCȂ画𔽓]
		if( mediums.size() == 1 &&  agi.agentState[mediums.get(0)].causeofDeath == CauseOfDeath.ALIVE ){
			if( result == Species.HUMAN ){
				// oꍇ̎_肷
				future = new ViewpointInfo(agi.selfViewInfo);
				future.removeWolfPattern(inspectAgentNo);
				// _ŗ\mlOȂ烉C邽ߔ蔽]
				if( future.isFixWolfSide(mediums.get(0)) ){
					result = Species.WEREWOLF;
				}
			}else{
				// oꍇ̎_肷
				future = new ViewpointInfo(agi.selfViewInfo);
				future.removePatternFromJudge(agi.latestGameInfo.getAgent().getAgentIdx(), inspectAgentNo, Species.WEREWOLF);
				// _ŗ\mlOȂ烉C邽ߔ蔽]
				if( future.isFixWolfSide(mediums.get(0)) ){
					result = Species.HUMAN;
				}
			}
		}

		Judge newJudge = new Judge( getMe().getAgentIdx(),
		                            inspectAgentNo,
		                            result,
		                            null );

		agi.addFakeSeerJudge(newJudge);

	}



}
