package jp.halfmoon.inaba.aiwolf.guess;

import jp.halfmoon.inaba.aiwolf.condition.RoleCondition;
import jp.halfmoon.inaba.aiwolf.learn.AgentStatistics;
import jp.halfmoon.inaba.aiwolf.lib.CauseOfDeath;
import org.aiwolf.common.data.Role;

import java.util.ArrayList;

/**
 * uPړ[錾vNX
 */
public final class Learn_1dVoteSaid extends AbstractGuessStrategy {

	AgentStatistics agentStatistics;

	public Learn_1dVoteSaid(AgentStatistics agentStatistics){
		this.agentStatistics = agentStatistics;
	}

	@Override
	public ArrayList<Guess> getGuessList(GuessStrategyArgs args) {
		// Xg
		ArrayList<Guess> guesses = new ArrayList<Guess>();

		// ͍sȂ
		if( args.agi.latestGameInfo.getDay() < 1 ){
			return guesses;
		}

		// 10ł͍sȂ
		if( args.agi.latestGameInfo.getDay() == 1 && args.agi.getMyTalkNum() == 0 ){
			return guesses;
		}

		for( int agentNo = 1; agentNo <= args.agi.gameSetting.getPlayerNum(); agentNo++ ){

			Integer target = args.agi.getSaidVoteAgent(agentNo, 1);

			// 錾̏ꍇ
			if( target == null ){

				ArrayList<Guess> rguesses = agentStatistics.statistics.get(agentNo).getGuessFromEvent("NoSaid1dVote", args.agi.gameSetting);

				for( Guess guess : rguesses ){
					guesses.add(guess);
				}

			}else{

				ArrayList<Guess> rguesses = agentStatistics.statistics.get(agentNo).getGuessFromEvent("Said1dVote", args.agi.gameSetting);

				for( Guess guess : rguesses ){
					guesses.add(guess);
				}

			}

		}

		// XgԂ
		return guesses;
	}

}
