package jp.halfmoon.inaba.aiwolf.request;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.net.GameInfo;

import jp.halfmoon.inaba.aiwolf.guess.InspectedWolfsidePattern;
import jp.halfmoon.inaba.aiwolf.lib.CauseOfDeath;
import jp.halfmoon.inaba.aiwolf.lib.Common;


/**
 * spuoXisv
 */
public final class BalanceExecute extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		GameInfo gameInfo = args.agi.latestGameInfo;

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;

		// ꐔvZ
		int executeNum = Common.getRestExecuteCount(gameInfo.getAliveAgentList().size());

		//TODO ҐΉ
		// orŏIȂvZ͍sȂ
		if( gameInfo.getDay() < 3 || executeNum <= 1 ){
			return Requests;
		}

		// lOp^[̍őXRA
		double maxScore = args.aguess.getMostValidPattern().score;

		// PPtO
		HashMap<Integer, Double> PPMaxScore = new HashMap<Integer, Double>();

		// SlOp^[𑖍
		for( InspectedWolfsidePattern iPattern : args.aguess.getAllPattern().values() ){

			double score = iPattern.score;

			// XRAp^[͖
			if( score < maxScore * 0.2 ){
				continue;
			}

			// lÕJEg
			int aliveWolfSideNum = 0;
			for( int wolf : iPattern.pattern.wolfAgentNo ){
				if( args.agi.agentState[wolf].causeofDeath == CauseOfDeath.ALIVE ){
					aliveWolfSideNum++;
				}
			}
			for( int possessed : iPattern.pattern.possessedAgentNo ){
				if( args.agi.agentState[possessed].causeofDeath == CauseOfDeath.ALIVE ){
					aliveWolfSideNum++;
				}
			}

			// ݂~XPPɂȂ邩i݂萔lOłΊYj
			if( executeNum == aliveWolfSideNum ){
				// TwcɊ܂܂Ȃ҂݂PP
				for( Agent agent : gameInfo.getAliveAgentList() ){
					int agentNo = agent.getAgentIdx();
					if( !iPattern.pattern.isWolfSide(agentNo) ){
						// PPő̃XRA擾
						if( !PPMaxScore.containsKey(agentNo) || PPMaxScore.get(agentNo) < score ){
							PPMaxScore.put(agentNo, score);
						}
					}
				}
			}

		}

		// ݂PPȐl͂ȂׂX[
		if( PPMaxScore.size() != gameInfo.getAliveAgentList().size() ){
			for( Map.Entry<Integer, Double> set : PPMaxScore.entrySet() ){
				workReq = new Request(set.getKey());
				workReq.vote = 0.4;
				Requests.add(workReq);
			}
		}


		return Requests;

	}

}
