package jp.halfmoon.inaba.aiwolf.request;

import jp.halfmoon.inaba.aiwolf.lib.Judge;
import jp.halfmoon.inaba.aiwolf.lib.VoteAnalyzer;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.net.GameInfo;

import java.util.ArrayList;
import java.util.List;


/**
 * spu肢݂v
 */
public final class SeerExecute extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		GameInfo gameInfo = args.agi.latestGameInfo;

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;

		// ͏YȂ̂ŕKvȂ
		if( gameInfo.getDay() <= 0 ){
			return Requests;
		}

		// Sڂ܂ł͂Ƃ肠sȂ
		if( args.agi.getMyTalkNum() < 4 ){
			return Requests;
		}


		// 錾ςݓ[͂̕擾
		VoteAnalyzer voteAnalyzer = VoteAnalyzer.loadSaidVote(args.agi);



		// P[łĂ
		if( !voteAnalyzer.getMaxReceiveVoteAgent().isEmpty() ){

			// [MAX擾
			int receiveVoteCountMax = voteAnalyzer.getReceiveVoteCount(voteAnalyzer.getMaxReceiveVoteAgent().get(0));

			List<Integer> seers = args.agi.getEnableCOAgentNo(Role.SEER);

			for( Integer seer : seers ){
				// lO̓XLbv
				if( args.agi.getAliveWolfList().contains(seer) ){
					continue;
				}
				for( Judge judge : args.agi.getSeerJudgeList() ){
					// Ԉo
					if( (judge.result == Species.WEREWOLF) != args.agi.isWolf(judge.targetAgentNo) ){
						continue;
					}
				}

				// G[WFg̓[擾
				int receiveVoteCount = voteAnalyzer.receiveVoteCount.getOrDefault(Agent.getAgent(seer), 0);

				// ̓[[MAX-1ȏȂ牟
				if( receiveVoteCount >= receiveVoteCountMax - 1 ){
					workReq = new Request(seer);
					workReq.vote = 12.00;
					Requests.add(workReq);
				}
			}

		}

		return Requests;

	}

}
