package jp.halfmoon.inaba.aiwolf.request;

import java.util.ArrayList;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;

import jp.halfmoon.inaba.aiwolf.lib.VoteAnalyzer;


/**
 * spu[dˁv
 * {z肷铮́Aʂ\݂Ă邱ƁB
 */
public final class VoteStack extends AbstractActionStrategy {

	@Override
	public ArrayList<Request> getRequests(ActionStrategyArgs args) {

		GameInfo gameInfo = args.agi.latestGameInfo;

		ArrayList<Request> Requests = new ArrayList<Request>();
		Request workReq;



		// 錾ςݓ[͂̕擾
		VoteAnalyzer voteAnalyzer = VoteAnalyzer.loadSaidVote(args.agi);

		// Ă[ɉĕ[d˂
		for( Agent agent : gameInfo.getAliveAgentList() ){
			workReq = new Request(agent);
			workReq.vote = 1.00 + voteAnalyzer.getReceiveVoteCount(agent) * 0.05 * (1 + voteAnalyzer.getReceiveVoteCount(gameInfo.getAgent()) * 0.10);
			Requests.add(workReq);
		}

		// Sȍ~AĂO[Ⴂ͓[vi4ڂ܂Łj
		if( gameInfo.getAliveAgentList().size() >= 7 && args.agi.getMyTalkNum() > 3 ){
			// ̓[擾
			Agent voteAgent = voteAnalyzer.getVoteTarget(gameInfo.getAgent());
			for( Agent agent : gameInfo.getAliveAgentList() ){
				int voteCount = voteAnalyzer.getReceiveVoteCount(agent) - ( agent.equals(voteAgent) ? 1 : 0 );
				if( voteCount <= 0 ){
					workReq = new Request(agent);
					workReq.vote = 0.5;
					Requests.add(workReq);
				}
			}

		}

		return Requests;

	}

}
